<?php
// Start session and connect to the database
session_start();
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

// Retrieve visitor's IP address
$ipAddress = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];

// Generate session ID
$sessionId = session_id();

// Check if the visitor already exists in the database
$result = $mysqli->query("SELECT id FROM visitors WHERE session_id = '$sessionId'");
if ($result->num_rows == 0) {
    // Visitor doesn't exist, insert new record
    $mysqli->query("INSERT INTO visitors (ip_address, session_id) VALUES ('$ipAddress', '$sessionId')");
}

// Retrieve and store location data
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $latitude = $_POST['latitude'];
    $longitude = $_POST['longitude'];

    // Update latitude and longitude values for the visitor
    $mysqli->query("UPDATE visitors SET latitude = '$latitude', longitude = '$longitude' WHERE session_id = '$sessionId'");
}

function calculateDistance($lat1, $lon1, $lat2, $lon2) {
    if ($lat1 === null || $lon1 === null || $lat2 === null || $lon2 === null) {
        // Invalid latitude or longitude values
        return null; // Return null instead of 0 for invalid distance
    }
    $earthRadius = 6371; // Earth's radius in kilometers

    $dLat = deg2rad($lat2 - $lat1);
    $dLon = deg2rad($lon2 - $lon1);

    $a = sin($dLat / 2) * sin($dLat / 2) + cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * sin($dLon / 2) * sin($dLon / 2);
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    $distance = $earthRadius * $c;

    return $distance;
}

$productsPerPage = 6; // Number of products to display per page
$startIndex = isset($_GET['startIndex']) ? intval($_GET['startIndex']) : 0; // Start index for fetching products

// Retrieve user information from table 1
$category = $_GET['category'] ?? ''; // Get the specified category from the query string

if (!empty($category)) {
    $sql1 = "SELECT product_id, product_name, price, image1, state, latitude, longitude, category FROM products WHERE category = '$category'";
} else {
    $sql1 = "SELECT product_id, product_name, price, image1, state, latitude, longitude, category FROM products";
}

$result1 = $mysqli->query($sql1);

// Retrieve user information from table 2
$sql2 = "SELECT id, latitude, longitude FROM visitors WHERE session_id = '$sessionId'";
$result2 = $mysqli->query($sql2);

$distances = array();

if ($result1->num_rows > 0 && $result2->num_rows > 0) {
    // Fetch user data from table 1
    $users1 = array();
    while ($row1 = $result1->fetch_assoc()) {
        $users1[] = $row1;
    }

    // Fetch user data from table 2
    $users2 = array();
    while ($row2 = $result2->fetch_assoc()) {
        $users2[] = $row2;
    }

    // Calculate distances between users from table 1 and table 2
    foreach ($users1 as $i => $user1) {
        foreach ($users2 as $user2) {
            $distance = calculateDistance($user1['latitude'], $user1['longitude'], $user2['latitude'], $user2['longitude']);
            $distances[$users1[$i]['product_id']] = $distance;
        }
    }

    // Sort the distances in ascending order
    asort($distances);
}

// Close the database connection
$mysqli->close();
?>

<!DOCTYPE html>
<html>
<head>
    <title>Search</title>
</head>
<body>
    <div class="products">
        <?php
        // Display the search results
        if (!empty($category) && !empty($distances)) {
            $products = array_slice($distances, $startIndex, $productsPerPage, true);

            foreach ($products as $productId => $distance) {
                $product = array_filter($users1, function ($user) use ($productId) {
                    return $user['product_id'] == $productId;
                });

                if (!empty($product)) {
                    $product = reset($product);

                    // Extract product details
                    $productId = $product['product_id'];
                    $productName = $product['product_name'];
                    $price = $product['price'];
                    $image1 = $product['image1'];
                    $state = $product['state'];

                    // Display the product information
                    ?>
                    <a href="subcategory.php?subcategory=<?php echo urlencode($productId); ?>&subcategory_name=<?php echo urlencode($productName); ?>&category_name=<?php echo urlencode($category); ?>" class="cad">
                        <img src="user/productimages/<?php echo htmlspecialchars($image1, ENT_QUOTES); ?>" alt="<?php echo htmlspecialchars($productName, ENT_QUOTES); ?>">
                        <div class="text-block">
                            <p><?php echo htmlspecialchars($price, ENT_QUOTES); ?></p>
                        </div>
                        <div class="cadcontent">
                            <h6 style="margin-bottom: 5px;"><?php echo htmlspecialchars($productName, ENT_QUOTES); ?></h6>
                            <p style="margin-bottom: 0;"><i class="fa fa-map-mark"></i> <?php echo htmlspecialchars($state, ENT_QUOTES); ?></p>
                            <p style="margin-bottom: 0;"><i class="fa fa-map-mark"></i> <?php echo $distance !== null ? number_format($distance, 1, '.', '') . ' KM' : ''; ?></p>
                        </div>
                    </a>
                    <?php
                }
            }

            if ($startIndex + $productsPerPage < count($distances)) {
                ?>
                <div class="load-more-container">
                    <button id="loadMoreBtn" onclick="loadMoreProducts()">Load More</button>
                </div>
                <?php
            }
        } else {
            echo "No products found.";
        }
        ?>
    </div>

    <script>
        var startIndex = <?php echo $startIndex; ?>;
        var productsPerPage = <?php echo $productsPerPage; ?>;
        var totalProducts = <?php echo count($distances); ?>;

        function loadMoreProducts() {
            var loadMoreBtn = document.getElementById('loadMoreBtn');
            var productsContainer = document.querySelector('.products');

            startIndex += productsPerPage;

            if (startIndex >= totalProducts) {
                loadMoreBtn.style.display = 'none'; // Hide the "Load More" button if there are no more products
            }

            fetch('fetch_cate.php?startIndex=' + startIndex)
                .then(response => response.text())
                .then(html => {
                    productsContainer.innerHTML += html;
                })
                .catch(error => {
                    console.log('Error fetching products:', error);
                });
        }
    </script>
</body>
</html>
