<?php
// Start session and connect to the database
session_start();
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

// Retrieve user information from table 1
$sql1 = "SELECT product_id, product_name, price, image1, state, latitude, longitude FROM products";
$result1 = $mysqli->query($sql1);

// Retrieve user information from table 2
$sessionId = session_id();
$sql2 = "SELECT id, latitude, longitude FROM visitors WHERE session_id = '$sessionId'";
$result2 = $mysqli->query($sql2);

$distances = array();

if ($result1->num_rows > 0 && $result2->num_rows > 0) {

    // Fetch user data from table 1
    $users1 = array();
    while ($row1 = $result1->fetch_assoc()) {
        $users1[] = $row1;
    }

    // Fetch user data from table 2
    $users2 = array();
    while ($row2 = $result2->fetch_assoc()) {
        $users2[] = $row2;
    }

    // Calculate distances between users from table 1 and table 2
    for ($i = 0; $i < count($users1); $i++) {
        for ($j = 0; $j < count($users2); $j++) {
            $distance = calculateDistance($users1[$i]['latitude'], $users1[$i]['longitude'], $users2[$j]['latitude'], $users2[$j]['longitude']);
            $distances[] = [
                'product_id' => $users1[$i]['product_id'],
                'visitor_id' => $users2[$j]['id'],
                'distance' => $distance
            ];
        }
    }
}

$mysqli->close();

$startIndex = $_GET['startIndex'];
$productsPerPage = 8;
$endIndex = min($startIndex + $productsPerPage, count($distances));

if (!empty($distances)) {
    for ($i = $startIndex; $i < $endIndex; $i++) {
        $distance = $distances[$i];
        $product_id = $distance['product_id'];
        $state = '';
        foreach ($users1 as $user1) {
            if ($user1['product_id'] == $product_id) {
                $product_name = $user1['product_name'];
                if (strlen($product_name) > 16) {
                    $product_name = substr($product_name, 0, 16) . '...';
                }
                $price = $user1['price'];
                $image1 = $user1['image1'];
                $state = $user1['state'];
                break;
            }
        }
        ?>
        <a href="products.php?id=<?php echo $product_id; ?>" class="cad">
            <img src="user/productimages/<?php echo $image1; ?>" alt="<?php echo $product_name; ?>">
            <div class="text-block">
                <p><?php echo $price; ?></p>
            </div>
            <div class="cadcontent">
                <h6 style="margin-bottom: 5px;"><?php echo $product_name; ?></h6>
                <p style="margin-bottom: 0;"><i class="fa fa-map-mark"></i> <?php echo $state . ' ' . ($distance['distance'] !== null ? number_format($distance['distance'], 1, '.', '') : ''); ?> KM</p>
            </div>
        </a>
        <?php
    }
} else {
    echo "No products found.";
}

/**
 * Calculate the distance between two sets of latitude and longitude coordinates.
 *
 * @param float $lat1 Latitude of the first location.
 * @param float $lon1 Longitude of the first location.
 * @param float $lat2 Latitude of the second location.
 * @param float $lon2 Longitude of the second location.
 * @param string $unit Unit of distance (optional, default is "K").
 * @return float The calculated distance between the two locations.
 */
function calculateDistance($lat1, $lon1, $lat2, $lon2, $unit = "K")
{
    $theta = $lon1 - $lon2;
    $distance = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) + cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
    $distance = acos($distance);
    $distance = rad2deg($distance);
    $distance = $distance * 60 * 1.1515;
    if ($unit == "K") {
        $distance = $distance * 1.609344;
    } elseif ($unit == "N") {
        $distance = $distance * 0.8684;
    }
    return $distance;
}
?>
