<?php
// Start session and connect to the database
session_start();
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

// Retrieve visitor's IP address
$ipAddress = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];

// Generate session ID
$sessionId = session_id();

// Check if the visitor already exists in the database
$result = $mysqli->query("SELECT id FROM visitors WHERE session_id = '$sessionId'");
if ($result->num_rows == 0) {
    // Visitor doesn't exist, insert new record
    $mysqli->query("INSERT INTO visitors (ip_address, session_id) VALUES ('$ipAddress', '$sessionId')");
}

// Retrieve and store location data
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $latitude = $_POST['latitude'];
    $longitude = $_POST['longitude'];

    // Update latitude and longitude values for the visitor
    $mysqli->query("UPDATE visitors SET latitude = '$latitude', longitude = '$longitude' WHERE session_id = '$sessionId'");
}

function calculateDistance($lat1, $lon1, $lat2, $lon2) {
    if ($lat1 === null || $lon1 === null || $lat2 === null || $lon2 === null) {
        // Invalid latitude or longitude values
        return 0; // Return a default value instead of null
    }
    $earthRadius = 6371; // Earth's radius in kilometers

    $dLat = deg2rad($lat2 - $lat1);
    $dLon = deg2rad($lon2 - $lon1);

    $a = sin($dLat / 2) * sin($dLat / 2) + cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * sin($dLon / 2) * sin($dLon / 2);
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    $distance = $earthRadius * $c;

    return $distance;
}

$category = isset($_GET['category']) ? $_GET['category'] : null;
$subcategory = isset($_GET['subcategory']) ? $_GET['subcategory'] : null;

// Prepare the query to fetch products based on the selected category or subcategory
if (!empty($subcategory)) {
  $query = 'SELECT product_id, merchant_id, category, subcategory, type, product_name, price, state, latitude, longitude, image1 FROM products WHERE subcategory = ?';
  $param = $subcategory;
} elseif (!empty($category)) {
  $query = 'SELECT product_id, merchant_id, category, subcategory, type, product_name, price, state, latitude, longitude, image1 FROM products WHERE category = ?';
  $param = $category;
} else {
  // Invalid request, both category and subcategory are empty
  echo json_encode([]);
  exit();
}

// Retrieve user information from visitors table
$sql = "SELECT id, latitude, longitude FROM visitors WHERE session_id = '$sessionId'";
$result = $mysqli->query($sql);

$distances = array();

if ($result->num_rows > 0) {
    $visitor = $result->fetch_assoc();
    $visitorLatitude = $visitor['latitude'];
    $visitorLongitude = $visitor['longitude'];

    // Fetch products and calculate distances
    $stmt = $mysqli->prepare($query);
    $stmt->bind_param('s', $param);
    $stmt->execute();
    $result = $stmt->get_result();

    // Prepare the final products array with distances
    while ($row = $result->fetch_assoc()) {
        $productLatitude = $row['latitude'];
        $productLongitude = $row['longitude'];

        $distance = calculateDistance($visitorLatitude, $visitorLongitude, $productLatitude, $productLongitude);

        $product = array(
            'product_id' => $row['product_id'],
            'merchant_id' => $row['merchant_id'],
            'category' => $row['category'],
            'subcategory' => $row['subcategory'],
            'type' => $row['type'],
            'product_name' => $row['product_name'],
            'price' => $row['price'],
            'state' => $row['state'],
            'latitude' => $row['latitude'],
            'longitude' => $row['longitude'],
            'image1' => $row['image1'],
            'distance' => $distance
        );

        $products[] = $product;
    }
}

$mysqli->close();

// Output the final products array as JSON
echo json_encode($products);
?>
