<?php
// Connect to the database (replace 'hostname', 'username', 'password', and 'database' with your actual credentials)
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

// Check for connection errors
if ($mysqli->connect_errno) {
  echo 'Failed to connect to MySQL: ' . $mysqli->connect_error;
  exit();
}

// Retrieve the category ID from the request
$categoryID = $_GET['category'];

// Fetch subcategories based on the category ID
$query = 'SELECT DISTINCT subcategory FROM products WHERE category = ?';
$stmt = $mysqli->prepare($query);
$stmt->bind_param('i', $categoryID);
$stmt->execute();
$result = $stmt->get_result();

// Check for query errors
if (!$result) {
  echo 'Error executing query: ' . $mysqli->error;
  exit();
}

// Fetch the subcategories and store them in an array
$subcategories = array();
while ($row = $result->fetch_assoc()) {
  $subcategories[] = $row['subcategory'];
}

// Close the prepared statement
$stmt->close();

// Convert the subcategories array to JSON and send the response
echo json_encode($subcategories);

// Close the database connection
$mysqli->close();
?>
