<?php
// Connect to the database (replace 'hostname', 'username', 'password', and 'database' with your actual credentials)
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

// Check for database connection errors
if ($mysqli->connect_errno) {
  echo 'Failed to connect to MySQL: ' . $mysqli->connect_error;
  exit();
}

// Retrieve the selected category ID from the AJAX request
$category = $_GET['category'];

// Prepare the query to fetch subcategories based on the selected category
$query = 'SELECT id, name FROM subcategories WHERE category_id = ?';

// Prepare the statement
$stmt = $mysqli->prepare($query);

// Check for query preparation errors
if (!$stmt) {
  echo 'Error preparing statement: ' . $mysqli->error;
  exit();
}

// Bind the category parameter
$stmt->bind_param('s', $category);

// Execute the statement
if ($stmt->execute()) {
  // Fetch the result
  $result = $stmt->get_result();

  // Create an array to store the subcategory information
  $subcategories = [];

  // Iterate over the result and fetch the subcategory information
  while ($row = $result->fetch_assoc()) {
    $subcategories[] = $row;
  }

  // Close the result set
  $result->close();

  // Close the statement
  $stmt->close();

  // Generate the HTML for subcategory links
  foreach ($subcategories as $subcategory) {
    $subcategoryId = $subcategory['id'];
    $subcategoryName = $subcategory['name'];
    ?>
    <a href="#" class="subcategoryLink" data-subcategory="<?php echo $subcategoryId; ?>"><?php echo $subcategoryName; ?></a>
    <?php
  }
} else {
  // Error executing the statement
  echo 'Error executing query: ' . $stmt->error;
}

// Close the database connection
$mysqli->close();
?>
