<?php
// Start session and connect to the database
session_start();
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');
$locationAllowed = $_SESSION['location_allowed'] ?? false;
// Retrieve visitor's IP address
$ipAddress = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];

// Generate session ID
$sessionId = session_id();

// Check if the visitor already exists in the database
$result = $mysqli->query("SELECT id FROM visitors WHERE session_id = '$sessionId'");
if ($result->num_rows == 0) {
    // Visitor doesn't exist, insert new record
    $mysqli->query("INSERT INTO visitors (ip_address, session_id) VALUES ('$ipAddress', '$sessionId')");
}

// Retrieve and store location data
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $latitude = $_POST['latitude'];
    $longitude = $_POST['longitude'];

    // Check if location data is already stored in the session
    if (!isset($_SESSION['location_data'])) {
        // Store location data in the session
        $_SESSION['location_data'] = ['latitude' => $latitude, 'longitude' => $longitude];

        // Update latitude and longitude values for the visitor
        $mysqli->query("UPDATE visitors SET latitude = '$latitude', longitude = '$longitude' WHERE session_id = '$sessionId'");
    }

    // Redirect to index.php
    header("Location: index.php");
    exit(); // Terminate script execution after redirect
}

function calculateDistance($lat1, $lon1, $lat2, $lon2) {
    if ($lat1 === null || $lon1 === null || $lat2 === null || $lon2 === null) {
        // Invalid latitude or longitude values
        return 0; // Return a default value instead of null
    }
    $earthRadius = 6371; // Earth's radius in kilometers

    $dLat = deg2rad($lat2 - $lat1);
    $dLon = deg2rad($lon2 - $lon1);

    $a = sin($dLat / 2) * sin($dLat / 2) + cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * sin($dLon / 2) * sin($dLon / 2);
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    $distance = $earthRadius * $c;

    return $distance;
}

// Retrieve user information from table 1
$sql1 = "SELECT product_id, product_name, price, image1, state, latitude, longitude FROM products";
$result1 = $mysqli->query($sql1);

// Retrieve user information from table 2
$sql2 = "SELECT id, latitude, longitude FROM visitors WHERE session_id = '$sessionId'";
$result2 = $mysqli->query($sql2);

$distances = array();

if ($result1->num_rows > 0 && $result2->num_rows > 0) {

    // Fetch user data from table 1
    $users1 = array();
    while ($row1 = $result1->fetch_assoc()) {
        $users1[] = $row1;
    }

    // Fetch user data from table 2
    $users2 = array();
    while ($row2 = $result2->fetch_assoc()) {
        $users2[] = $row2;
    }

    // Calculate distances between users from table 1 and table 2
    for ($i = 0; $i < count($users1); $i++) {
        for ($j = 0; $j < count($users2); $j++) {
            $distance = calculateDistance($users1[$i]['latitude'], $users1[$i]['longitude'], $users2[$j]['latitude'], $users2[$j]['longitude']);
            $distances[] = [
                'product_id' => $users1[$i]['product_id'],
                'visitor_id' => $users2[$j]['id'],
                'distance' => $distance
            ];
        }
    }
}

$mysqli->close();
?>

<script>
    // Get visitor's current location
    function getLocation(forceLocation) {
        return new Promise((resolve, reject) => {
            if (forceLocation && navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(
                    position => resolve(position.coords),
                    error => reject(error)
                );
            } else {
                fetch('https://nominatim.openstreetmap.org/?format=json&ip=<?php echo $ipAddress; ?>')
                    .then(response => response.json())
                    .then(data => {
                        if (data && data.lat && data.lon) {
                            resolve({
                                latitude: parseFloat(data.lat),
                                longitude: parseFloat(data.lon)
                            });
                        } else {
                            reject(new Error('Failed to retrieve location.'));
                        }
                    })
                    .catch(error => reject(error));
            }
        });
    }

    // Send location data to the server
    function sendLocationData(latitude, longitude, forceLocation) {
        return new Promise((resolve, reject) => {
            var xhr = new XMLHttpRequest();
            xhr.open('POST', 'location.php', true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.onreadystatechange = function() {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // Check if the location data has already been stored in the session
                        if (!<?php echo isset($_SESSION['location_data']) ? 'true' : 'false'; ?>) {
                            // Redirect to index.php after location data is stored
                            window.location.href = 'index.php';
                        }
                    } else {
                        reject(new Error('Failed to send location data.'));
                    }
                }
            };
            xhr.send('latitude=' + latitude + '&longitude=' + longitude + '&forceLocation=' + (forceLocation ? '1' : '0'));
        });
    }

    // Update distances dynamically
    function updateDistances() {
        var distancesContainer = document.getElementById('distances-container');

        fetch('.php')
            .then(response => response.text())
            .then(html => {
                distancesContainer.innerHTML = html;
            })
            .catch(error => {
                distancesContainer.innerHTML = 'Error: ' + error.message;
            });
    }

    // Enforce location detection and auto-load distances
    function getLocationAndLoadDistances(forceLocation) {
        getLocation(forceLocation)
            .then(coords => {
                var { latitude, longitude } = coords;

                // Send location data to the server
                return sendLocationData(latitude, longitude, forceLocation);
            })
            .then(() => {
                // Update distances dynamically
                updateDistances();

                // Refresh distances every 30 seconds
                setInterval(updateDistances, 30000);
            })
            .catch(error => {
                console.log(error);
                var distancesContainer = document.getElementById('distances-container');
                distancesContainer.innerHTML = 'Error: ' + error.message;
            });
    }

    // Load distances on page load
    getLocationAndLoadDistances(true);
</script>

