<?php
// Start session and connect to the database
session_start();
$mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

// Retrieve visitor's IP address
$ipAddress = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];

// Generate session ID
$sessionId = session_id();

// Check if the visitor already exists in the database
$result = $mysqli->query("SELECT id FROM visitors WHERE session_id = '$sessionId'");
if ($result->num_rows == 0) {
    // Visitor doesn't exist, insert new record
    $mysqli->query("INSERT INTO visitors (ip_address, session_id) VALUES ('$ipAddress', '$sessionId')");
}

// Retrieve and store location data
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $latitude = $_POST['latitude'] ?? null;
    $longitude = $_POST['longitude'] ?? null;

    // Update latitude and longitude values for the visitor
    $mysqli->query("UPDATE visitors SET latitude = '$latitude', longitude = '$longitude' WHERE session_id = '$sessionId'");
}

function calculateDistance($lat1, $lon1, $lat2, $lon2) {
    if ($lat1 === null || $lon1 === null || $lat2 === null || $lon2 === null) {
        // Invalid latitude or longitude values
        return 0; // Return a default value instead of null
    }
    $earthRadius = 6371; // Earth's radius in kilometers

    $dLat = deg2rad($lat2 - $lat1);
    $dLon = deg2rad($lon2 - $lon1);

    $a = sin($dLat / 2) * sin($dLat / 2) + cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * sin($dLon / 2) * sin($dLon / 2);
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    $distance = $earthRadius * $c;

    return $distance;
}

// Retrieve user information from table 1
$query = $_GET['query'] ?? '';
$country = $_GET['country'] ?? '';
$state = $_GET['state'] ?? '';
$startIndex = $_GET['startIndex'] ?? 0; // Get the start index for loading products
$productsPerPage = 6; // Number of products to display per page
$sql1 = "SELECT product_id, product_name, product_description price, image1, state, latitude, longitude FROM products WHERE 1";
if (!empty($query)) {
    $sql1 .= " AND product_name LIKE '%$query%'";
}
if (!empty($country) && empty($state)) {
    $sql1 .= " AND country = '$country'";
}
if (!empty($country) && !empty($state)) {
    $sql1 .= " AND country = '$country' AND state = '$state'";
}
$sql1 .= " LIMIT $startIndex, $productsPerPage"; // Add the LIMIT clause to fetch products based on the start index and number of products per page
$result1 = $mysqli->query($sql1);

$distances = array();

if ($result1->num_rows > 0) {
    // Fetch user data from table 1
    $users1 = array();
    while ($row1 = $result1->fetch_assoc()) {
        $users1[] = $row1;
    }

    // Retrieve user information from table 2
    $sql2 = "SELECT id, latitude, longitude FROM visitors WHERE session_id = '$sessionId'";
    $result2 = $mysqli->query($sql2);

    if ($result2->num_rows > 0) {
        // Fetch user data from table 2
        $users2 = array();
        while ($row2 = $result2->fetch_assoc()) {
            $users2[] = $row2;
        }

        // Calculate distances between users from table 1 and table 2
        foreach ($users1 as $user1) {
            foreach ($users2 as $user2) {
                $distance = calculateDistance($user1['latitude'], $user1['longitude'], $user2['latitude'], $user2['longitude']);
                $distances[$user1['product_id']] = $distance;
            }
        }
    }
}

// Close the database connection
$mysqli->close();
?>
<link href="css/netsaf.css" rel="stylesheet">
<div class="products">
    <?php if (!empty($query) || (!empty($country) && empty($state)) || (!empty($country) && !empty($state))): ?>
        <?php if ($result1->num_rows > 0): ?>
            <?php foreach ($users1 as $user): ?>
                <?php
                $productId = $user['product_id'];
                $image1 = $user['image1'];
                $product_name = $user['product_name'];
                $price = $user['price'];
                $state = $user['state'];
                $distance = isset($distances[$productId]) ? $distances[$productId] : 0;
                 // Add the product to the displayed products array
            $displayedProducts[] = $product_id;
            
            // Trim the product name if it exceeds 16 characters
            if (strlen($product_name) > 16) {
                $product_name = substr($product_name, 0, 16) . '...';
            }
                ?>
                <a href="products.php?id=<?php echo $productId; ?>" class="cad">
                    <img src="user/productimages/<?php echo $image1; ?>" alt="<?php echo $product_name; ?>">
                    <div class="text-block">
                        <p><?php echo $price; ?></p>
                    </div>
                    <div class="cadcontent">
                        <h6 style="margin-bottom: 5px;"><?php echo $product_name; ?></h6>
                        <p style="margin-bottom: 0;"><i class="fa fa-map-mark"></i> <?php echo $state . ' ' . number_format($distance, 1, '.', '') . ' KM'; ?></p>
                    </div>
                </a>
            <?php endforeach; ?>
        <?php else: ?>
            <p>No products found.</p>
        <?php endif; ?>
    <?php else: ?>
        <p>Please enter a search query, country, and state.</p>
    <?php endif; ?>
</div>

<div class="load-more-container">
    <?php if ($result1->num_rows >= $productsPerPage): ?>
        <button id="loadMoreBtn" onclick="loadMoreProducts()">Load More</button>
    <?php endif; ?>
</div>

<script>
    var startIndex = <?php echo $startIndex; ?>;
    var productsPerPage = <?php echo $productsPerPage; ?>;
    var totalProducts = <?php echo count($distances); ?>;

    function loadMoreProducts() {
        var loadMoreBtn = document.getElementById('loadMoreBtn');
        var productsContainer = document.querySelector('.products');

        startIndex += productsPerPage;

        if (startIndex >= totalProducts) {
            loadMoreBtn.style.display = 'none'; // Hide the "Load More" button if there are no more products
        }

        fetch('fetch_products.php?startIndex=' + startIndex)
            .then(response => response.text())
            .then(html => {
                productsContainer.innerHTML += html;
            })
            .catch(error => {
                console.log('Error fetching products:', error);
            });
    }
</script>
