<?php
require_once 'catlocation.php';
?>

<!DOCTYPE html>
<html>
<head>
  <title>Product Categories</title>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
   <style>
.categories {
  
  overflow-x: auto;
  white-space: nowrap;
}

.categories li {
  display: inline-block;
  margin-right: 0;
  width: 62px;
  height: 62px;
}

.categories li a {
  text-decoration: none;
  color: #000;
  font-size: 12px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.2); /* Added box shadow */
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  height: 100%;
  text-align: center;
  white-space: nowrap; /* Prevent the category text from wrapping to the next line */
  margin-right: 0; /* Remove the space between categories */
}

.categories li a i {
  display: none; /* Hide the icon */
}

.categories li a.active {
  text-decoration: underline;
  color: green;
  font-weight: bold;
  border-radius: 2px;
  padding: 2px;
}

.second {
  display: none; /* Hide the subcategories by default */
  position: absolute; /* Position the subcategories absolutely */
  width: 100%;
  margin-right: 10px;
  overflow: auto;
  white-space: nowrap;
  padding: 8px;
}

.second.show {
  display: flex; /* Show the subcategories when the category is clicked */
  margin-left: 10px;
}

.second a {
  display: inline-block;
  margin-right: 10px;
  background-color: green;
  white-space: normal; /* Add this line to wrap long links */
}

#products {
  margin-top: 60px; /* Add space below the category and subcategory links */
}

/* Horizontal layout with scroll for mobile */
@media screen and (max-width: 767px) {
  .categories {
    overflow-x: scroll;
    overflow-y: hidden;
    -webkit-overflow-scrolling: touch;
  }

  .categories li {
    display: inline-block;
    margin-right: 1px;
  }
}

/* Add this CSS rule to remove the default link color */
.product a {
  color: inherit;
  text-decoration: none;
}

/* Rest of your existing CSS code */
.product {
  display: flex;
  flex-wrap: wrap;
  justify-content: flex-start;
  background-color: #fafafa;
}

    .cad {
      width: calc(16.6667% - 10px);
      background-color: #fff;
      margin-bottom: 20px;
      margin-right: 5px;
      margin-left: 5px;
      padding: 0;
      position: relative;
      box-shadow: 0 2px 4px rgba(0, 0, 0, 0.2); /* Added box shadow */
    }

    .cad img {
      width: 100%;
      height: 150px; /* Update the image height as per your requirement */
      display: block;
    }

    .text-block {
      position: absolute;
      top: 65%;
      left: 80%;
      transform: translate(-50%, -50%);
      background-color: green;
      color: white;
      padding: 2px;
      width: auto;
      height: auto;
      text-align: center;
    }

    .cadcontent {
      padding: 0;
      text-align: center;
      margin-bottom: 0;
    }

    .cadcontent h6,
    .cadcontent p {
      margin: 0;
    }

    .text-block p {
      margin: 0;
      width: 100%;
      height: auto;
      color: white;
    }

    /* Add the following CSS rule to reduce the font size of h6 */
    .cadcontent h6 {
      font-size: 15px;
    } 

    @media (max-width: 767px) {
      .product {
        justify-content: center;
      }

      .cad {
        width: calc(50% - 26px);
        margin-right: 13px;
        margin-left: 13px;
      }
    }

    @media (min-width: 768px) {
      .cad.desktop-hidden {
        display: none;
      }
    }

    @media (max-width: 767px) {
      .cad.mobile-hidden {
        display: none;
      }
    }
  </style>
</head>
<body>
  <div class="categories">
    <?php
    // Start session and connect to the database
    session_start();
    $mysqli = new mysqli('localhost', 'sharhine_adds', '@mashaAllah1', 'sharhine_tv');

    // Retrieve visitor's IP address
    $ipAddress = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];

    // Generate session ID
    $sessionId = session_id();

    // Check if the visitor already exists in the database
    $result = $mysqli->query("SELECT id FROM visitors WHERE session_id = '$sessionId'");
    if ($result->num_rows == 0) {
        // Visitor doesn't exist, insert new record
        $mysqli->query("INSERT INTO visitors (ip_address, session_id) VALUES ('$ipAddress', '$sessionId')");
    }

    // Retrieve and store location data
    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        $latitude = $_POST['latitude'];
        $longitude = $_POST['longitude'];

        // Update latitude and longitude values for the visitor
        $mysqli->query("UPDATE visitors SET latitude = '$latitude', longitude = '$longitude' WHERE session_id = '$sessionId'");
    }

    // Fetch categories from the database
    $query = 'SELECT id, name, icon FROM categories';
    $result = $mysqli->query($query);

    // Check for query errors
    if (!$result) {
        echo 'Error executing query: ' . $mysqli->error;
        exit();
    }

    // Loop through the categories and create links
    while ($row = $result->fetch_assoc()) {
        $categoryId = $row['id'];
        $categoryName = $row['name'];
        $categoryIcon = $row['icon'];
        ?>
        <li>
            <a href="#" class="category-link" data-category-id="<?php echo $categoryId; ?>">
                <img src="<?php echo $categoryIcon; ?>" alt="<?php echo $categoryName; ?>" width="32" height="32">
                <?php echo $categoryName; ?>
            </a>

            <div class="second">
                <?php
                // Fetch subcategories for the current category
                $subQuery = 'SELECT id, name FROM subcategories WHERE category_id = ' . $categoryId;
                $subResult = $mysqli->query($subQuery);

                // Check for query errors
                if (!$subResult) {
                    echo 'Error executing subcategory query: ' . $mysqli->error;
                    exit();
                }

                // Loop through the subcategories and display their names
                while ($subRow = $subResult->fetch_assoc()) {
                    $subcategoryId = $subRow['id'];
                    $subcategoryName = $subRow['name'];
                    ?>
                    <a href="#" class="subcategory-link" data-category-id="<?php echo $categoryId; ?>" data-subcategory-id="<?php echo $subcategoryId; ?>"><?php echo $subcategoryName; ?></a>
                    <?php
                }
                ?>
            </div>
        </li>
        <?php
    }

    $mysqli->close();
    ?>
  </div>

  <div id="products">
  </div>

  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
  <script>
    // Update the product list based on the selected category and subcategory
    function updateProductList(categoryId, subcategoryId) {
      var url = 'getproducts.php';

      // Prepare the data to be sent with the AJAX request
      var data = {};
      if (categoryId) {
        data.category = categoryId;
      }
      if (subcategoryId) {
        data.subcategory = subcategoryId;
      }

      // Send the AJAX request
      $.ajax({
        url: url,
        type: 'GET',
        data: data,
        success: function(response) {
          var products = JSON.parse(response);

          // Sort the products based on their distance in ascending order
          products.sort(function(a, b) {
            return a.distance - b.distance;
          });

          // Clear the existing product list
          $('#products').empty();

          // Generate the product HTML and append it to the product list
          products.forEach(function(product) {
            var productHtml = '<div class="product">' +
              '<a href="products.php?id=' + product.product_id + '" class="cad">' +
              '<img src="user/productimages/' + product.image1 + '" alt="' + product.product_name + '">' +
              '<div class="text-block">' +
              '<p>' + product.price + '</p>' +
              '</div>' +
              '<div class="cadcontent">' +
              '<h6 style="margin-bottom: 5px;">' + product.product_name + '</h6>' +
              '<p style="margin-bottom: 0;"><i class="fa fa-map-mark"></i> ' + product.state + ' ' + (product.distance !== null ? Number.parseFloat(product.distance).toFixed(1) : '') + ' KM</p>' +
              '</div>' +
              '</a>' +
              '</div>';

            $('#products').append(productHtml);
          });
          
        },
        error: function() {
          alert('Error retrieving products.');
        }
      });
    }

    // Event handler for category links
    $('.category-link').click(function(e) {
      e.preventDefault();

      // Get the selected category ID
      var categoryId = $(this).data('category-id');

      // Remove the active class from all category links and add it to the clicked link
      $('.category-link').removeClass('active');
      $(this).addClass('active');

      // Hide all subcategories
      $('.second').removeClass('show');

      // Show the subcategories for the clicked category
      $(this).siblings('.second').addClass('show');

      // Update the product list based on the selected category
      updateProductList(categoryId, null);
    });

    // Event handler for subcategory links
    $('.subcategory-link').click(function(e) {
      e.preventDefault();

      // Get the selected category ID and subcategory ID
      var categoryId = $(this).data('category-id');
      var subcategoryId = $(this).data('subcategory-id');

      // Remove the active class from all subcategory links and add it to the clicked link
      $('.subcategory-link').removeClass('active');
      $(this).addClass('active');

      // Update the product list based on the selected category and subcategory
      updateProductList(categoryId, subcategoryId);
    });

    // Load the initial product list on page load
    updateProductList(null, null);
  </script>
</body>
</html>
