<?php
session_start();
require_once('../con/con.php');

if (!isset($_SESSION["emailOrPhone"])) {
    header("Location: login.php");
    exit();
}

$emailOrPhone = $_SESSION["emailOrPhone"];


if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

$sql = "SELECT *, country, state, market FROM merchants WHERE email = '$emailOrPhone' OR phone = '$emailOrPhone'";
$result = $conn->query($sql);
$row = $result->fetch_assoc();

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Retrieve the submitted form data
    $category = $_POST['category'];
    $type = $_POST['type'];
    $product_name = $_POST['product_name'];
    $product_description = $_POST['product_description'];

    // Optional room-related fields
    $room = $_POST['room'] ?? null;
    $farlow = $_POST['farlow'] ?? null;
    $toilet = $_POST['toilet'] ?? null;
    $kitchen = $_POST['kitchen'] ?? null;
    $dining_room = $_POST['dining_room'] ?? null;

    // Retrieve additional merchant information
    $country = $row['country'];
    $state = $row['state'];
    $market = $row['market'];

    // Retrieve latitude and longitude
    $latitude = $_POST["latitude"];
    $longitude = $_POST["longitude"];

    // Retrieve the merchant_id from the merchant table
    $merchant_id = $row['merchant_id'];

    // Handle image resizing and saving
    $targetDir = "productimages/"; // Set your target directory here

    for ($i = 1; $i <= 10; $i++) {
        $fileKey = "image" . $i;
        if (isset($_FILES[$fileKey])) {
            $file = $_FILES[$fileKey];
            $targetFile = basename($file['name']);
            $imageFileType = strtolower(pathinfo($targetFile, PATHINFO_EXTENSION));

            // Check if the uploaded file is an image
            if (getimagesize($file['tmp_name'])) {
                // Create a new image from the uploaded file
                $sourceImage = imagecreatefromstring(file_get_contents($file['tmp_name']));

                // Calculate the target width and height based on the desired file size
                $targetSize = 250 * 1024; // 250KB
                $sourceSize = filesize($file['tmp_name']);
                $compressionRatio = $targetSize / $sourceSize;
                $targetWidth = imagesx($sourceImage) * sqrt($compressionRatio);
                $targetHeight = imagesy($sourceImage) * sqrt($compressionRatio);

                // Create a new blank image with the target width and height
                $resizedImage = imagecreatetruecolor($targetWidth, $targetHeight);

                // Resize the source image to the target size
                imagecopyresampled($resizedImage, $sourceImage, 0, 0, 0, 0, $targetWidth, $targetHeight, imagesx($sourceImage), imagesy($sourceImage));

                // Save the resized image with JPEG format and a target quality of 80%
                imagejpeg($resizedImage, $targetDir . $targetFile, 80);

                // Free up memory
                imagedestroy($sourceImage);
                imagedestroy($resizedImage);

                // Save the file path to the database
                $filePath = $targetDir . $targetFile;
                $insertImageQuery = "INSERT INTO images (product_id, image_path) VALUES ('$product_id', '$filePath')";
                $conn->query($insertImageQuery);
            }
        }
    }

    // Update the product information in the database
    $updateProductQuery = "UPDATE products SET category='$category', type='$type', product_name='$product_name', product_description='$product_description', room='$room', farlow='$farlow', toilet='$toilet', kitchen='$kitchen', dining_room='$dining_room', latitude='$latitude', longitude='$longitude' WHERE merchant_id='$merchant_id'";
    $conn->query($updateProductQuery);

    // Redirect to the merchant dashboard
    header("Location: dashboard.php");
    exit();
}

$conn->close();
?>

<!DOCTYPE html>
<html>

<head>
    <title>Edit Product</title>
    <link rel="stylesheet" type="text/css" href="styles.css">
</head>

<body>
    <div class="container">
        <h2>Edit Product</h2>
        <form action="" method="POST" enctype="multipart/form-data">
            <div class="form-group">
                <label for="category">Category:</label>
                <input type="text" name="category" id="category" value="<?php echo $row['category']; ?>" required>
            </div>
            <div class="form-group">
                <label for="type">Type:</label>
                <input type="text" name="type" id="type" value="<?php echo $row['type']; ?>" required>
            </div>
            <div class="form-group">
                <label for="product_name">Product Name:</label>
                <input type="text" name="product_name" id="product_name" value="<?php echo $row['product_name']; ?>" required>
            </div>
            <div class="form-group">
                <label for="product_description">Product Description:</label>
                <textarea name="product_description" id="product_description" required><?php echo $row['product_description']; ?></textarea>
            </div>
            <div class="form-group">
                <label for="room">Room:</label>
                <input type="checkbox" name="room" id="room" value="1" <?php if ($row['room'] == 1) echo "checked"; ?>>
            </div>
            <div class="form-group">
                <label for="farlow">Farlow:</label>
                <input type="checkbox" name="farlow" id="farlow" value="1" <?php if ($row['farlow'] == 1) echo "checked"; ?>>
            </div>
            <div class="form-group">
                <label for="toilet">Toilet:</label>
                <input type="checkbox" name="toilet" id="toilet" value="1" <?php if ($row['toilet'] == 1) echo "checked"; ?>>
            </div>
            <div class="form-group">
                <label for="kitchen">Kitchen:</label>
                <input type="checkbox" name="kitchen" id="kitchen" value="1" <?php if ($row['kitchen'] == 1) echo "checked"; ?>>
            </div>
            <div class="form-group">
                <label for="dining_room">Dining Room:</label>
                <input type="checkbox" name="dining_room" id="dining_room" value="1" <?php if ($row['dining_room'] == 1) echo "checked"; ?>>
            </div>
            <div class="form-group">
                <label for="latitude">Latitude:</label>
                <input type="text" name="latitude" id="latitude" value="<?php echo $row['latitude']; ?>" required>
            </div>
            <div class="form-group">
                <label for="longitude">Longitude:</label>
                <input type="text" name="longitude" id="longitude" value="<?php echo $row['longitude']; ?>" required>
            </div>
            <div class="form-group">
                <label for="image1">Image 1:</label>
                <input type="file" name="image1" id="image1">
            </div>
            <div class="form-group">
                <label for="image2">Image 2:</label>
                <input type="file" name="image2" id="image2">
            </div>
            <div class="form-group">
                <label for="image3">Image 3:</label>
                <input type="file" name="image3" id="image3">
            </div>
            <div class="form-group">
                <label for="image4">Image 4:</label>
                <input type="file" name="image4" id="image4">
            </div>
            <div class="form-group">
                <label for="image5">Image 5:</label>
                <input type="file" name="image5" id="image5">
            </div>
            <div class="form-group">
                <label for="image6">Image 6:</label>
                <input type="file" name="image6" id="image6">
            </div>
            <div class="form-group">
                <label for="image7">Image 7:</label>
                <input type="file" name="image7" id="image7">
            </div>
            <div class="form-group">
                <label for="image8">Image 8:</label>
                <input type="file" name="image8" id="image8">
            </div>
            <div class="form-group">
                <label for="image9">Image 9:</label>
                <input type="file" name="image9" id="image9">
            </div>
            <div class="form-group">
                <label for="image10">Image 10:</label>
                <input type="file" name="image10" id="image10">
            </div>
            <button type="submit" class="btn">Submit</button>
        </form>
    </div>
</body>

</html>
