<?php
require_once('con/con.php');

// Check if the latitude and longitude values are posted
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST["latitude"]) && isset($_POST["longitude"])) {
    $latitude = $_POST["latitude"];
    $longitude = $_POST["longitude"];

    // Check if the location already exists in the database
    $sql = "SELECT * FROM user_location WHERE latitude = '$latitude' AND longitude = '$longitude'";
    $result = $conn->query($sql);

    if ($result->num_rows == 0) {
        // Insert the location into the database
        $sql = "INSERT INTO user_location (latitude, longitude) VALUES ('$latitude', '$longitude')";
        if ($conn->query($sql) === TRUE) {
            $session_id = uniqid(); // Generate a unique session ID
            $_SESSION["session_id"] = $session_id; // Store the session ID in a PHP session variable

            echo "Location saved successfully.";
        } else {
            echo "Error: " . $sql . "<br>" . $conn->error;
        }
    }

    $conn->close();
    exit; // Terminate the script execution after handling the request
}

// Check if the user has a valid session ID and perform auto-login if available
if (isset($_SESSION["session_id"])) {
    $session_id = $_SESSION["session_id"];

    // Perform your auto-login logic here
    // Example: Set user authentication state or retrieve user information based on the session ID

    // Fetch the product details based on the product_id and calculate the distance
    $product_id = $_GET["product_id"];
    $sql = "SELECT product_name, price, latitude, longitude, (6371 * acos(cos(radians($latitude)) * cos(radians(latitude)) * cos(radians(longitude) - radians($longitude)) + sin(radians($latitude)) * sin(radians(latitude)))) AS distance FROM products WHERE product_id = '$product_id'";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $product_name = $row["product_name"];
            $price = $row["price"];
            $distance = $row["distance"];

            echo "Product Name: " . $product_name . "<br>";
            echo "Price: " . $price . "<br>";
            echo "Distance: " . $distance . " km<br><br>";
        }
    } else {
        echo "Product not found.";
    }
}
?>
<!DOCTYPE html>
<html>
<head>
    <title>OpenStreetMap Location Detection</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
</head>
<body>
    <script>
        function getLocation() {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(showPosition);
            } else {
                console.log("Geolocation is not supported by this browser.");
            }
        }

        function showPosition(position) {
            var latitude = position.coords.latitude;
            var longitude = position.coords.longitude;

            // Send the latitude and longitude values via AJAX request
            $.ajax({
                type: "POST",
                url: "index.php",
                data: { latitude: latitude, longitude: longitude },
                success: function(response) {
                    console.log(response); // Output the response from the PHP script
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    console.log("AJAX request failed: " + textStatus + ", " + errorThrown);
                }
            });
        }

        // Call the getLocation function only when there is no latitude and longitude in the URL parameters
        if (!window.location.search.includes("latitude") && !window.location.search.includes("longitude")) {
            getLocation();
        }
    </script>
</body>
</html>
