<?php
require_once('con/con.php');
session_start();

if (isset($_POST['login'])) {
    $emailOrPhone = $_POST['email_or_phone'];
    $password = $_POST['password'];

    // Use prepared statement to prevent SQL injection
    $stmt = $conn->prepare("SELECT * FROM merchants WHERE (email = ? OR phone = ?) AND password = ?");
    $stmt->bind_param("sss", $emailOrPhone, $emailOrPhone, $password);
    $stmt->execute();
    $result = $stmt->get_result();

    if ($result->num_rows == 1) {
        // Fetch the user data
        $user = $result->fetch_assoc();

        // Store user data in the session
        $_SESSION['merchant_id'] = $user['id'];
        $_SESSION['emailOrPhone'] = $user['email']; // or $user['phone']


        // Redirect to the dashboard
        header("Location: user/post.php");
        exit();
    } else {
        // Authentication failed
        echo "Invalid credentials";
    }

    $stmt->close();
}
?>

<!DOCTYPE html>
<html>
<head>
    <title>Login</title>
</head>
<body>
    <h2>Login</h2>
    <form method="POST" action="">
        <label for="email_or_phone">Email or Phone:</label>
        <input type="text" name="email_or_phone" id="email_or_phone" required><br><br>

        <label for="password">Password:</label>
        <input type="password" name="password" id="password" required><br><br>

        <input type="submit" name="login" value="Login">
    </form>
</body>
</html>
