<?php
session_start();

$servername = "localhost";
$username = "sharhine_adds";
$password = "@mashaAllah1";
$dbname = "sharhine_tv";

// Create a database connection
$connection = mysqli_connect($servername, $username, $password, $dbname);



// Step 1: Registration form
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST["register"])) {
    $fullname = $_POST["fullname"];
    $email = $_POST["email"];
    $phone = $_POST["phone"];
    $password = $_POST["password"];
    $confirmPassword = $_POST["confirm_password"];
  $latitude = $_POST["latitude"];
$longitude = $_POST["longitude"];

    // Perform email format and password match checks
    if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
        echo "Invalid email format";
        return;
    }
    if ($password != $confirmPassword) {
        echo "Passwords do not match";
        return;
    }

    // Check if email or phone already exist in the database
    $query = "SELECT * FROM merchants WHERE email = ? OR phone = ?";
    $stmt = mysqli_prepare($connection, $query);
    mysqli_stmt_bind_param($stmt, "ss", $email, $phone);
    mysqli_stmt_execute($stmt);
    $result = mysqli_stmt_get_result($stmt);
    if (mysqli_num_rows($result) > 0) {
        $row = mysqli_fetch_assoc($result);
        if ($row["email"] == $email) {
            echo "Email already exists";
        } elseif ($row["phone"] == $phone) {
            echo "Phone number already exists";
        }
        return;
    }

    // Insert the user into the database
    $query = "INSERT INTO merchants (fullname, email, phone, password, latitude, longitude) VALUES (?, ?, ?, ?, ?, ?)";
    $stmt = mysqli_prepare($connection, $query);
    mysqli_stmt_bind_param($stmt, "ssssss", $fullname, $email, $phone, $password,  $latitude, $longitude);
    $result = mysqli_stmt_execute($stmt);
    if ($result) {
        // Registration successful, move to the next step
        $_SESSION["current_step"] = 2;
        $_SESSION["merchant_id"] = mysqli_insert_id($connection);
    } else {
        echo "Registration failed";
    }
}

// Step 2: Select Shop Owner or Non-Shop Owner
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST["select_account_type"])) {
    $accountType = $_POST["account_type"];

    // Save the selected account type in the session
    $_SESSION["account_type"] = $accountType;

    // Move to the next step
    if ($accountType == "shop_owner") {
        $_SESSION["current_step"] = 3;
    } else {
        $_SESSION["current_step"] = 4;
    }
}

// Step 3: Shop Owner form
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST["shop_owner_form"])) {
    $userId = $_SESSION["merchant_id"];
    $shopName = $_POST["shop_name"];
    $country = $_POST["country"];
    $state = $_POST["state"];
    $market = $_POST["market"];
    $shopadd = $_POST["shopadd"];
    $accountName = $_POST["account_name"];
    $bankName = $_POST["bank_name"];
    $accountNo = $_POST["account_no"];
    $contactAddress = $_POST["contact_address"];
    $contactNo = $_POST["contact_no"];
    $companyRegNo = $_POST["company_reg_no"];
    $otherInfo = $_POST["other_info"];
    

    // Perform data validation if required

    // Update the user profile in the database
    $query = "UPDATE merchants SET shop_name = ?, country = ?, state = ?, market = ?, shopadd = ?, account_name = ?, bank_name = ?, account_no = ?, contact_address = ?, contact_no = ?, company_reg_no = ?, other_info = ? WHERE merchant_id = ?";
    $stmt = mysqli_prepare($connection, $query);
    mysqli_stmt_bind_param($stmt, "ssssssssssssi", $shopName, $country, $state, $market, $shopadd, $accountName, $bankName, $accountNo, $contactAddress, $contactNo, $companyRegNo, $otherInfo, $userId);
    $result = mysqli_stmt_execute($stmt);
    if ($result) {
        // Shop owner profile completed successfully
        $_SESSION["current_step"] = 5; // Move to Step 5 or the completion page
    } else {
        echo "Failed to update profile";
    }
}

// Step 4: Non-Shop Owner form
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST["non_shop_owner_form"])) {
    $userId = $_SESSION["merchant_id"];
    $country = $_POST["country"];
    $state = $_POST["state"];
    $contactAddress = $_POST["contact_address"];
    $contactNo = $_POST["contact_no"];
    $accountName = $_POST["account_name"];
    $bankName = $_POST["bank_name"];
    $accountNo = $_POST["account_no"];

    // Perform data validation if required

    // Update the user profile in the database
    $query = "UPDATE merchants SET country = ?, state = ?, contact_address = ?, contact_no = ?, account_name = ?, bank_name = ?, account_no = ? WHERE merchant_id = ?";
    $stmt = mysqli_prepare($connection, $query);
    mysqli_stmt_bind_param($stmt, "sssssssi", $country, $state, $contactAddress, $contactNo, $accountName, $bankName, $accountNo, $userId);
    $result = mysqli_stmt_execute($stmt);
    if ($result) {
        // Non-shop owner profile completed successfully
        $_SESSION["current_step"] = 5; // Move to Step 5 or the completion page
    } else {
        echo "Failed to update profile";
    }
}

// Check the current step from the session
$currentStep = isset($_SESSION["current_step"]) ? $_SESSION["current_step"] : 1;

// Close the database connection
mysqli_close($connection);
?>

<!DOCTYPE html>
<html>
<head>
    <title>Registration</title>
    
    <script>
    function nextStep(nextStepNumber) {
        document.getElementById("step" + nextStepNumber).style.display = "block";
        document.getElementById("step" + (nextStepNumber - 1)).style.display = "none";
    }

    function previousStep(previousStepNumber) {
        document.getElementById("step" + previousStepNumber).style.display = "block";
        document.getElementById("step" + (previousStepNumber + 1)).style.display = "none";
    }
</script>
		<link href="css/user.css" rel="stylesheet">
</head>
<body>
    <?php if ($currentStep == 1): ?>
        <!-- Step 1: Registration form -->
        <form action="reg.php" method="POST">
            <input type="text" name="fullname" placeholder="Full Name" required><br>
            <input type="email" name="email" placeholder="Email" required><br>
            <input type="number" name="phone" placeholder="Phone Number" required><br>
            <input type="password" name="password" placeholder="Password" required><br>
            <input type="password" name="confirm_password" placeholder="Confirm Password" required><br>
 
<input type="hidden" name="latitude" id="latitude" required><br>


<input type="hidden" name="longitude" id="longitude" required><br>

            <input type="submit" name="register" value="Register">
        </form>
    <?php elseif ($currentStep == 2): ?>
        <!-- Step 2: Select Shop Owner or Non-Shop Owner -->
        <form action="reg.php" method="POST">
            <input type="radio" name="account_type" value="shop_owner" required> Shop Owner<br>
            <input type="radio" name="account_type" value="non_shop_owner" required> Non-Shop Owner<br>
            <input type="submit" name="select_account_type" value="Next">
        </form>
  <?php elseif ($currentStep == 3): ?>
    <!-- Shop Owner Form -->
    <form action="reg.php" method="POST" id="shopOwnerForm">
        <!-- Step 1: Shop Name, Country, State, Market -->
        <div id="step1">
         
            <input type="text" name="shop_name" placeholder="Shop Name" required><br>
            
<select name="country" id="country">
    <option value="" selected="selected">Select country</option>
  </select>
  <br><br>
  states: <select name="state" id="state">
    <option value="" selected="selected">Please select country first</option>
  </select>
  <br><br>
  markets: <select name="market" id="market">
    <option value="" selected="selected">Please select state first</option>
  </select>
  
  <input type="text" name="shopadd" placeholder="Shop Address" required><br>
  <br><br>
	  <script type= "text/javascript" src = "js/market.js"></script>
           
            <button type="button" onclick="nextStep(2)">Next</button>
        </div>

        <!-- Step 2: Account Name, Bank Name, Account Number -->
        <div id="step2" style="display: none;">
            <input type="text" name="account_name" placeholder="Account Name" required><br>
            <input type="text" name="bank_name" placeholder="Bank Name" required><br>
            <input type="number" name="account_no" placeholder="Account Number" required><br>
            <button type="button" onclick="previousStep(1)">Previous</button>
            <button type="button" onclick="nextStep(3)">Next</button>
        </div>

        <!-- Step 3: Contact Address, Contact Number, Company Registration Number, Other Information -->
        <div id="step3" style="display: none;">
            <input type="text" name="contact_address" placeholder="Contact Address" required><br>
            <input type="number" name="contact_no" placeholder="Contact Number" required><br>
            <input type="text" name="company_reg_no" placeholder="Company Registration Number"><br>
            <textarea name="other_info" placeholder="Other Information"></textarea><br>
            <button type="button" onclick="previousStep(2)">Previous</button>
            <input type="submit" name="shop_owner_form" value="Submit">
        </div>
    </form>
<?php elseif ($currentStep == 4): ?>
    <!-- Non-Shop Owner Form -->
    <form action="reg.php" method="POST" id="nonShopOwnerForm">
        <!-- Step 1: Country, State, Contact Address, Contact Number -->
        <div id="step1">
            <input type="text" name="country" placeholder="Country" required><br>
            <input type="text" name="state" placeholder="State" required><br>
            <input type="text" name="contact_address" placeholder="Contact Address" required><br>
            <input type="text" name="contact_no" placeholder="Contact Number" required><br>
            <button type="button" onclick="nextStep(2)">Next</button>
        </div>

        <!-- Step 2: Account Name, Bank Name, Account Number -->
        <div id="step2" style="display: none;">
            <input type="text" name="account_name" placeholder="Account Name" required><br>
            <input type="text" name="bank_name" placeholder="Bank Name" required><br>
            <input type="text" name="account_no" placeholder="Account Number" required><br>
            <button type="number" onclick="previousStep(1)">Previous</button>
            <input type="submit" name="non_shop_owner_form" value="Submit">
        </div>
    </form>
<?php elseif ($currentStep == 5): ?>
    <!-- Step 5: Completion page -->
    <h1>Registration completed successfully!</h1>
<?php endif; ?>




<script>
// Function to get the user's current location
function getLocation() {
  if (navigator.geolocation) {
    navigator.geolocation.getCurrentPosition(showPosition);
  } else {
    alert("Geolocation is not supported by this browser.");
  }
}

// Function to update the hidden input field with the location
// Function to update the input fields with latitude and longitude values
function showPosition(position) {
  var latitude = position.coords.latitude;
  var longitude = position.coords.longitude;
  var latitudeInput = document.getElementById("latitude");
  var longitudeInput = document.getElementById("longitude");
  latitudeInput.value = latitude;
  longitudeInput.value = longitude;
}
// Call getLocation when the page loads
window.onload = getLocation;
</script>



</body>  
</html> 
